unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, uPluginDefinition;

type

  { TMainApplikation }

  TMainApplikation = class(TInterfacedObject, IApplication)
    function GetLabelX : TLabel; stdcall;
  end;

  { TForm1 }

  TForm1 = class(TForm)
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    Main : TMainApplikation;
    PluginX: IPlugin;
    DLLHandle : THandle;
  end; 

type
   TLoadPlugin = function(out targetPlugin: IPlugin) : Boolean; stdcall;

var
  Form1: TForm1; 

implementation

uses
   dynlibs;

{ TMainApplikation }

function TMainApplikation.GetLabelX: TLabel; stdcall;
begin
   Result := Form1.Label1;
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
   LoadPlugin : TLoadPlugin;
begin
   main := TMainApplikation.Create;

   DLLHandle := LoadLibrary('plugin1.dll');
   if DLLHandle <> 0 then
   begin
     Pointer(LoadPlugin) := GetProcAddress(DLLHandle, 'LoadPlugin');

     if LoadPlugin(PluginX) then
       PluginX.SetApplication(main)
     else
       ShowMessage('failed');
   end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   main.Free;
   if DLLHandle <> 0 then
   UnloadLibrary(DLLHandle);
end;

initialization
  {$I unit1.lrs}

end.

